/* (c) Copyright 1993 by Bruce W. Watson */
#ifndef BENCH_H
#define BENCH_H

#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>

#define ITER (10)

/* start the timer and do some book-keeping */
#define START(x,y) auto int ctr; \
	auto struct rusage tb, te; \
	auto int res = getrusage( RUSAGE_SELF, &tb ); \
	auto unsigned long force = 0; \
	auto x *occ_beginning = y; \
	for( ctr = 0; ctr < ITER; ctr++ ) {

/* stop the timer and print out the times */
#define END(x,y) force |= ((unsigned)y | (unsigned)ctr); } \
	if( res || getrusage( RUSAGE_SELF, &te ) ) { \
		fputs( "getrusage failure", stderr ); \
		exit( -1 ); \
	} \
	printf( "%s %ld %ld %ld\n", #x, \
		(long)( (te.ru_utime.tv_sec - tb.ru_utime.tv_sec) * 1000000L + \
			(te.ru_utime.tv_usec - tb.ru_utime.tv_usec) ), \
		(long)(te.ru_minflt - tb.ru_minflt), \
		(long)(te.ru_majflt - tb.ru_majflt) ); \
	printf( "check %ld %ld\n", (long)(y - occ_beginning), (long)force ); \
	fflush( stdout )

#endif

