/* Copyright (c) 1993 by Bruce W. Watson */
#include "pattm.h"
#include "precomp.h"

/*
	Assume that gr, fr are allocated of size |suff(P)|
*/
void cw_d1_d2_precomp( const kw_t *P,
		suff_t gr[][V_SIZE],
		suff_t fr[],
		const kw_t *const CWOutput[],
		int d1[],
		int d2[],
		const suff_t last_suff,
		suff_t scratch[],
		suff_t right_drop[],
		const int suff_lengths[] ) {

	/* scratch[], right_drop[] must be of length |suff(P)| */
	auto suff_t u;
	auto suff_t au;
	auto suff_t v;
	auto char a;
	auto int ctr1
	auto int ctr2;

	ctr1 = 0;
	for( u = EPSILON; u <= last_suff; u++ ) {
		d1[u] = d2[u] = INFINITY;
	}
	for( a = 0; a < V_SIZE; a++ ) {
		if( gr[EPSILON][a] != BOTTOM ) {
			fr[gr[EPSILON][a]] = EPSILON;
			d1[EPSILON] = 1;
			if( CWOutput[gr[EPSILON][a]] != NULL ) {
				d2[EPSILON] = 1;
			}
			/* Now set up for BFS and right drop 1 of a suff */
			scratch[ctr1++] = gr[EPSILON][a];
			right_drop[gr[EPSILON][a]] = EPSILON;
		} else {
			gr[EPSILON][a] = EPSILON;
		}
	}

	scratch[ctr1] = BOTTOM;
	for( ctr2 = 0; scratch[ctr2] != BOTTOM; ctr2++ ) {
		/* update the next suff's for the BFS */
		for( a = 0; a < V_SIZE; a++ ) {
			if( gr[scratch[ctr2]][a] != BOTTOM ) {
				scratch[ctr1++] = gr[scratch[ctr2]][a];
				right_drop[gr[scratch[ctr2]][a]] = scratch[ctr2];
			}
		}
		scratch[ctr1] = BOTTOM;

		/* now main part of loop */
		u = scratch[ctr2];
		for( a = 0; a < V_SIZE; a++ ) {
			au = gr[u][a];

        		if( au != BOTTOM ) {
				fr[au] = gr[fr[u]][a];
				d1[fr[au]] =
					min(d1[fr[au]],(suff_lengths[au]-suff_lengths[fr[au]]));
				if( CWOutput[au] != NULL ) {
					/* au in P */
					v = fr[au];

            				while( v != EPSILON ) {
						d2[v] = min(d2[v],(suff_lengths[au]-suff_lengths[v]));
						v = fr[v];
					}
					d2[EPSILON] = min(d2[EPSILON],suff_lengths[au]);
				}
			} else {
				gr[u][a] = gr[fr[u]][a];
			}
		}
	}
	for( ctr2 = 0; scratch[ctr2] != BOTTOM; ctr2++ ) {
		d2[scratch[ctr2]] = min(d2[scratch[ctr2]],d2[right_drop[scratch[ctr2]]]);
	}
	return;
}


