/* (c) Copyright 1993 by Bruce W. Watson */
#include "pattm.h"

/*
	Expects to receive tau_ef already precomputed.
	Assume ACOutput precomputed for EPSILON and keywords.
*/
void gamma_f_precomp( pref_t gamma_f[][V_SIZE],
		pref_t f_f[],
		kw_t *ACOutput[],
		const pref_t tau_ef[][V_SIZE],
		pref_t scratch[] ) {

	auto pref_t u;
	auto pref_t ua;
	auto char a;
	auto int ctr1;
	auto int ctr2;

	u = EPSILON;
	for( a = 0; a < V_SIZE; a++ ) {
		gamma_f[EPSILON][a] = tau_ef[EPSILON][a];
		f_f[gamma_f[EPSILON][a]] = EPSILON;
		if( gamma_f[EPSILON][a] != EPSILON ) {
			/* a in pref(P) */
			/* set up for BFS */
			scratch[ctr1++] = gamma_f[EPSILON][a];
		}
	}
	scratch[ctr1] = BOTTOM;

	for( ctr2 = 0; scratch[ctr2] != BOTTOM; ctr2++ ) {
		/* update for next BFS */
		u = scratch[ctr2];
		for( a = 0; a < V_SIZE; a++ ) {
			if( tau_ef[u][a] != BOTTOM ) {
				scratch[ctr1++] = tau_ef[u][a];
			}
		}
		scratch[ctr1] = BOTTOM;

		if( ACOutput[u] == NULL ) {
			ACOutput[u] = ACOutput[f_f[u]];
		} else {
			/* u is a keyword */
			u->output_next = ACOutput[f_f[u]];
		}
		for( a = 0; a < V_SIZE; a++ ) {
			ua = tau_ef[u][a];

			if( ua != BOTTOM ) {
				gamma_f[u][a] = ua;
				f_f[ua] = gamma_f[f_f[u]][a];
			} else {
				gamma_f[u][a] = gamma_f[f_f[u]][a];
			}
		}
	}
	return;
}

