/* (c) Copyright 1993 by Bruce W. Watson */
#include "pattm.h"

/*
	Returns |pref(P)| - 1. Assume that tau_ef, ACOutput are |pref(P)|.
	ACOutput is only precomputed for pref's corresponding to EPSILON and keywords.
*/
int tau_ef_precomp( kw_t *P,
		pref_t tau_ef[][V_SIZE],
		const kw_t *ACOutput[] ) {

	auto pref_t last_pref;
	auto pref_t u;
	auto char a;
	auto const char *p;
	auto int v_hat;

	last_pref = EPSILON;
	for( a = 0; a < V_SIZE; a++ ) {
		tau_ef[EPSILON][a] = BOTTOM;
	}
	ACOutput[EPSILON] = NULL;
	while( !Empty(P) ) {
		p = P->p;
		u = EPSILON;
		v_hat = 0;

		while( v_hat < P->length ) {
			if( tau_ef[u][p[v_hat]] == BOTTOM ) {
				tau_ef[u][p[v_hat]] = ++last_pref;
				for( a = 0; a < V_SIZE; a++ ) {
					tau_ef[last_pref][a] = BOTTOM;
				}
				ACOutput[last_pref] = NULL;
			}
			u = tau_ef[u][p[v_hat]];
			v_hat++;
		}
		P->end_pref_or_suff = u;
		ACOutput[u] = P;
		P->output_next = NULL;
		P = Next(P);
	}
	for( a = 0; a < V_SIZE; a++ ) {
		if( tau_ef[EPSILON][a] == BOTTOM ) {
			tau_ef[EPSILON][a] = EPSILON;
		}
	}
	return( last_pref );
}
