/* (c) Copyright 1993 by Bruce W. Watson */
#include "pattm.h"

/*
	Returns |suff(P)| - 1.
	Assume suff_lengths is scratch memory of size |suff(P)|.
*/
suff_t tau_r_precomp( kw_t *P,
		suff_t tau_r[][V_SIZE],
		const kw_t *CWOutput[],
		int suff_lengths[] ) {

	auto suff_t last_suff;
	auto suff_t u;
	auto char a;
	auto const char *p;
	auto int v_hat;

	last_suff = EPSILON;
	for( a = 0; a < V_SIZE; a++ ) {
		tau_r[EPSILON][a] = BOTTOM;
	}
	suff_lengths[EPSILON] = 0;
	while( !Empty(P) ) {
		p = P->p;
		u = EPSILON;
		v_hat = P->length - 1;

		while( 0 <= v_hat ) {
			if( tau_r[u][p[v_hat]] == BOTTOM ) {
				tau_r[u][p[v_hat]] = ++last_suff;
				suff_lengths[last_suff] = suff_lengths[u] + 1;
				for( a = 0; a < V_SIZE; a++ ) {
					tau_r[last_suff][a] = BOTTOM;
				}
				CWOutput[last_suff] = NULL;
			}
			u = tau_r[u][p[v_hat]];
			v_hat--;
		}
		P->end_pref_or_suff = u;
		CWOutput[u] = P; P->output_next = NULL;
		P = Next(P);
	}
	return( last_suff );
}
